#include "keys.h"
#include "utils.h"
#include <string.h>
#include <stdlib.h>

skillerctl_name_value_pair_t keycodeLUT[] = {
    SK_KEY_ESC,            "esc",
    SK_KEY_F1,             "f1",
    SK_KEY_F2,             "f2",
    SK_KEY_F3,             "f3",
    SK_KEY_F4,             "f4",
    SK_KEY_F5,             "f5",
    SK_KEY_F6,             "f6",
    SK_KEY_F7,             "f7",
    SK_KEY_F8,             "f8",
    SK_KEY_F9,             "f9",
    SK_KEY_F10,            "f10",
    SK_KEY_F11,            "f11",
    SK_KEY_F12,            "f12",
    SK_KEY_PRTSC,          "prtsc",
    SK_KEY_PRTSC,          "printscreen",
    SK_KEY_PRTSC,          "prtscr",
    SK_KEY_SCROLL_LOCK,    "scrollock",
    SK_KEY_BREAK,          "pause",
    SK_KEY_BREAK,          "break",
    SK_KEY_TILDE,          "~",
    SK_KEY_TILDE,          "tilde",
    SK_KEY_1,              "1",
    SK_KEY_2,              "2",
    SK_KEY_3,              "3",
    SK_KEY_4,              "4",
    SK_KEY_5,              "5",
    SK_KEY_6,              "6",
    SK_KEY_7,              "7",
    SK_KEY_8,              "8",
    SK_KEY_9,              "9",
    SK_KEY_0,              "0",
    SK_KEY_MINUS,          "-",
    SK_KEY_EQUALS,         "=",
    SK_KEY_BACKSPACE,      "backspace",
    SK_KEY_INSERT,         "insert",
    SK_KEY_HOME,           "home",
    SK_KEY_PGUP,           "pgup",
    SK_KEY_NUMLOCK,        "numlock",
    SK_KEY_NUMDIV,         "numdiv",
    SK_KEY_NUMASTERISK,    "numasterisk",
    SK_KEY_NUMMINUS,       "numminus",
    SK_KEY_TAB,            "tab",
    SK_KEY_Q,              "q",
    SK_KEY_W,              "w",
    SK_KEY_E,              "e",
    SK_KEY_R,              "r",
    SK_KEY_T,              "t",
    SK_KEY_Y,              "y",
    SK_KEY_U,              "u",
    SK_KEY_I,              "i",
    SK_KEY_O,              "o",
    SK_KEY_P,              "p",
    SK_KEY_OPEN_BRACKET,   "[",
    SK_KEY_CLOSE_BRACKET,  "]",
    SK_KEY_BACKSLASH,      "]",
    SK_KEY_DELETE,         "delete",
    SK_KEY_DELETE,         "del",
    SK_KEY_END,            "end",
    SK_KEY_PGDOWN,         "pgdown",
    SK_KEY_NUM7,           "num7",
    SK_KEY_NUM8,           "num8",
    SK_KEY_NUM9,           "num9",
    SK_KEY_NUMPLUS,        "numplus",
    SK_KEY_CAPSLOCK,       "caps",
    SK_KEY_CAPSLOCK,       "capslock",
    SK_KEY_A,              "a",
    SK_KEY_S,              "s",
    SK_KEY_D,              "d",
    SK_KEY_F,              "f",
    SK_KEY_G,              "g",
    SK_KEY_H,              "h",
    SK_KEY_J,              "j",
    SK_KEY_K,              "k",
    SK_KEY_L,              "l",
    SK_KEY_COLON,          ";",
    SK_KEY_QUOTE,          "'",
    SK_KEY_ENTER,          "enter",
    SK_KEY_NUM4,           "num4",
    SK_KEY_NUM5,           "num5",
    SK_KEY_NUM6,           "num6",
    SK_KEY_LSHIFT,         "lshift",
    SK_KEY_Z,              "z",
    SK_KEY_X,              "x",
    SK_KEY_C,              "c",
    SK_KEY_V,              "v",
    SK_KEY_B,              "b",
    SK_KEY_N,              "n",
    SK_KEY_M,              "m",
    SK_KEY_COMMA,          ",",
    SK_KEY_DOT,            ".",
    SK_KEY_SLASH,          "/",
    SK_KEY_RSHIFT,         "rshift",
    SK_KEY_UP,             "up",
    SK_KEY_NUM1,           "num1",
    SK_KEY_NUM2,           "num2",
    SK_KEY_NUM3,           "num3",
    SK_KEY_NUMENTER,       "numenter",
    SK_KEY_LCTRL,          "lctrl",
    SK_KEY_LWIN,           "win",
    SK_KEY_LWIN,           "super",
    SK_KEY_LALT,           "lalt",
    SK_KEY_SPACE,          "space",
    SK_KEY_ALTGR,          "altgr",
    SK_KEY_ALTGR,          "ralt",
    SK_KEY_SHARKOON,       "sharkoon",
    SK_KEY_MENU,           "menu",
    SK_KEY_RCTRL,          "rctrl",
    SK_KEY_LEFT,           "left",
    SK_KEY_DOWN,           "down",
    SK_KEY_RIGHT,          "right",
    SK_KEY_NUM0,           "num0",
    SK_KEY_LWIN,           "lwin",
};

skillerctl_keyaddr_t skillerctl_keyaddr(const char* name)
{
    return skillerctl_lut_search(
            keycodeLUT,
            sizeof(keycodeLUT) / sizeof(skillerctl_name_value_pair_t), 
            name
   );
}

char* skillerctl_keystr(skillerctl_keyaddr_t key)
{
    switch (key) {
        case SK_KEY_BAD: return "SK_KEY_BAD";
        case SK_KEY_ESC: return "SK_KEY_ESC";
        case SK_KEY_F1: return "SK_KEY_F1";
        case SK_KEY_F2: return "SK_KEY_F2";
        case SK_KEY_F3: return "SK_KEY_F3";
        case SK_KEY_F4: return "SK_KEY_F4";
        case SK_KEY_F5: return "SK_KEY_F5";
        case SK_KEY_F6: return "SK_KEY_F6";
        case SK_KEY_F7: return "SK_KEY_F7";
        case SK_KEY_F8: return "SK_KEY_F8";
        case SK_KEY_F9: return "SK_KEY_F9";
        case SK_KEY_F10: return "SK_KEY_F10";
        case SK_KEY_F11: return "SK_KEY_F11";
        case SK_KEY_F12: return "SK_KEY_F12";
        case SK_KEY_PRTSC: return "SK_KEY_PRTSC";
        case SK_KEY_SCROLL_LOCK: return "SK_KEY_SCROLL_LOCK";
        case SK_KEY_BREAK: return "SK_KEY_BREAK";
        case SK_KEY_TILDE: return "SK_KEY_TILDE";
        case SK_KEY_1: return "SK_KEY_1";
        case SK_KEY_2: return "SK_KEY_2";
        case SK_KEY_3: return "SK_KEY_3";
        case SK_KEY_4: return "SK_KEY_4";
        case SK_KEY_5: return "SK_KEY_5";
        case SK_KEY_6: return "SK_KEY_6";
        case SK_KEY_7: return "SK_KEY_7";
        case SK_KEY_8: return "SK_KEY_8";
        case SK_KEY_9: return "SK_KEY_9";
        case SK_KEY_0: return "SK_KEY_0";
        case SK_KEY_MINUS: return "SK_KEY_MINUS";
        case SK_KEY_EQUALS: return "SK_KEY_EQUALS";
        case SK_KEY_BACKSPACE: return "SK_KEY_BACKSPACE";
        case SK_KEY_INSERT: return "SK_KEY_INSERT";
        case SK_KEY_HOME: return "SK_KEY_HOME";
        case SK_KEY_PGUP: return "SK_KEY_PGUP";
        case SK_KEY_NUMLOCK: return "SK_KEY_NUMLOCK";
        case SK_KEY_NUMDIV: return "SK_KEY_NUMDIV";
        case SK_KEY_NUMASTERISK: return "SK_KEY_NUMASTERISK";
        case SK_KEY_NUMMINUS: return "SK_KEY_NUMMINUS";
        case SK_KEY_TAB: return "SK_KEY_TAB";
        case SK_KEY_Q: return "SK_KEY_Q";
        case SK_KEY_W: return "SK_KEY_W";
        case SK_KEY_E: return "SK_KEY_E";
        case SK_KEY_R: return "SK_KEY_R";
        case SK_KEY_T: return "SK_KEY_T";
        case SK_KEY_Y: return "SK_KEY_Y";
        case SK_KEY_U: return "SK_KEY_U";
        case SK_KEY_I: return "SK_KEY_I";
        case SK_KEY_O: return "SK_KEY_O";
        case SK_KEY_P: return "SK_KEY_P";
        case SK_KEY_OPEN_BRACKET: return "SK_KEY_OPEN_BRACKET";
        case SK_KEY_CLOSE_BRACKET: return "SK_KEY_CLOSE_BRACKET";
        case SK_KEY_BACKSLASH: return "SK_KEY_BACKSLASH";
        case SK_KEY_DELETE: return "SK_KEY_DELETE";
        case SK_KEY_END: return "SK_KEY_END";
        case SK_KEY_PGDOWN: return "SK_KEY_PGDOWN";
        case SK_KEY_NUM7: return "SK_KEY_NUM7";
        case SK_KEY_NUM8: return "SK_KEY_NUM8";
        case SK_KEY_NUM9: return "SK_KEY_NUM9";
        case SK_KEY_NUMPLUS: return "SK_KEY_NUMPLUS";
        case SK_KEY_CAPSLOCK: return "SK_KEY_CAPSLOCK";
        case SK_KEY_A: return "SK_KEY_A";
        case SK_KEY_S: return "SK_KEY_S";
        case SK_KEY_D: return "SK_KEY_D";
        case SK_KEY_F: return "SK_KEY_F";
        case SK_KEY_G: return "SK_KEY_G";
        case SK_KEY_H: return "SK_KEY_H";
        case SK_KEY_J: return "SK_KEY_J";
        case SK_KEY_K: return "SK_KEY_K";
        case SK_KEY_L: return "SK_KEY_L";
        case SK_KEY_COLON: return "SK_KEY_COLON";
        case SK_KEY_QUOTE: return "SK_KEY_QUOTE";
        case SK_KEY_ENTER: return "SK_KEY_ENTER";
        case SK_KEY_NUM4: return "SK_KEY_NUM4";
        case SK_KEY_NUM5: return "SK_KEY_NUM5";
        case SK_KEY_NUM6: return "SK_KEY_NUM6";
        case SK_KEY_LSHIFT: return "SK_KEY_LSHIFT";
        case SK_KEY_Z: return "SK_KEY_Z";
        case SK_KEY_X: return "SK_KEY_X";
        case SK_KEY_C: return "SK_KEY_C";
        case SK_KEY_V: return "SK_KEY_V";
        case SK_KEY_B: return "SK_KEY_B";
        case SK_KEY_N: return "SK_KEY_N";
        case SK_KEY_M: return "SK_KEY_M";
        case SK_KEY_COMMA: return "SK_KEY_COMMA";
        case SK_KEY_DOT: return "SK_KEY_DOT";
        case SK_KEY_SLASH: return "SK_KEY_SLASH";
        case SK_KEY_RSHIFT: return "SK_KEY_RSHIFT";
        case SK_KEY_UP: return "SK_KEY_UP";
        case SK_KEY_NUM1: return "SK_KEY_NUM1";
        case SK_KEY_NUM2: return "SK_KEY_NUM2";
        case SK_KEY_NUM3: return "SK_KEY_NUM3";
        case SK_KEY_NUMENTER: return "SK_KEY_NUMENTER";
        case SK_KEY_LCTRL: return "SK_KEY_LCTRL";
        case SK_KEY_LWIN: return "SK_KEY_LWIN";
        case SK_KEY_LALT: return "SK_KEY_LALT";
        case SK_KEY_SPACE: return "SK_KEY_SPACE";
        case SK_KEY_ALTGR: return "SK_KEY_ALTGR";
        case SK_KEY_SHARKOON: return "SK_KEY_SHARKOON";
        case SK_KEY_MENU: return "SK_KEY_MENU";
        case SK_KEY_RCTRL: return "SK_KEY_RCTRL";
        case SK_KEY_LEFT: return "SK_KEY_LEFT";
        case SK_KEY_DOWN: return "SK_KEY_DOWN";
        case SK_KEY_RIGHT: return "SK_KEY_RIGHT";
        case SK_KEY_NUM0: return "SK_KEY_NUM0";
        case SK_KEY_NUMDEL: return "SK_KEY_NUMDEL";
    }

    return "SK_KEY_BAD";
}
