#ifndef KEYS_H
#define KEYS_H

#include <inttypes.h>

#define SK_KEY_BAD           0xffff
#define SK_KEY_ESC           0x0000
#define SK_KEY_F1            0x0003
#define SK_KEY_F2            0x0006
#define SK_KEY_F3            0x0009
#define SK_KEY_F4            0x000C
#define SK_KEY_F5            0x000F
#define SK_KEY_F6            0x0012
#define SK_KEY_F7            0x0015
#define SK_KEY_F8            0x0018
#define SK_KEY_F9            0x001B
#define SK_KEY_F10           0x001E
#define SK_KEY_F11           0x0021
#define SK_KEY_F12           0x0024
#define SK_KEY_PRTSC         0x002a
#define SK_KEY_SCROLL_LOCK   0x002d
#define SK_KEY_BREAK         0x0030
#define SK_KEY_TILDE         0x003f
#define SK_KEY_1             0x0042
#define SK_KEY_2             0x0045
#define SK_KEY_3             0x0048
#define SK_KEY_4             0x004b
#define SK_KEY_5             0x004e
#define SK_KEY_6             0x0051
#define SK_KEY_7             0x0054
#define SK_KEY_8             0x0057
#define SK_KEY_9             0x005A
#define SK_KEY_0             0x005D
#define SK_KEY_MINUS         0x0060
#define SK_KEY_EQUALS        0x0063
#define SK_KEY_BACKSPACE     0x0066
#define SK_KEY_INSERT        0x0069
#define SK_KEY_HOME          0x006c
#define SK_KEY_PGUP          0x006f
#define SK_KEY_NUMLOCK       0x0072
#define SK_KEY_NUMDIV        0x0075
#define SK_KEY_NUMASTERISK   0x0078
#define SK_KEY_NUMMINUS      0x007A
#define SK_KEY_TAB           0x007E
#define SK_KEY_Q             0x0081
#define SK_KEY_W             0x0084
#define SK_KEY_E             0x0087
#define SK_KEY_R             0x008A
#define SK_KEY_T             0x008D
#define SK_KEY_Y             0x0090
#define SK_KEY_U             0x0093
#define SK_KEY_I             0x0096
#define SK_KEY_O             0x0099
#define SK_KEY_P             0x009C
#define SK_KEY_OPEN_BRACKET  0x009F
#define SK_KEY_CLOSE_BRACKET 0x00A2
#define SK_KEY_BACKSLASH     0x00A5
#define SK_KEY_DELETE        0x00A8
#define SK_KEY_END           0x00AB
#define SK_KEY_PGDOWN        0x00AE
#define SK_KEY_NUM7          0x00B1
#define SK_KEY_NUM8          0x00B4
#define SK_KEY_NUM9          0x00B7
#define SK_KEY_NUMPLUS       0x00BA
#define SK_KEY_CAPSLOCK      0x00BD
#define SK_KEY_A             0x00C0
#define SK_KEY_S             0x00C3
#define SK_KEY_D             0x00C6
#define SK_KEY_F             0x00C9
#define SK_KEY_G             0x00CC
#define SK_KEY_H             0x00CF
#define SK_KEY_J             0x00D2
#define SK_KEY_K             0x00D5
#define SK_KEY_L             0x00D8
#define SK_KEY_COLON         0x00DB
#define SK_KEY_QUOTE         0x00DE
#define SK_KEY_ENTER         0x00E4
#define SK_KEY_NUM4          0x00F0
#define SK_KEY_NUM5          0x00F3
#define SK_KEY_NUM6          0x00F6
#define SK_KEY_LSHIFT        0x00FC
#define SK_KEY_Z             0x0102
#define SK_KEY_X             0x0105
#define SK_KEY_C             0x0108
#define SK_KEY_V             0x010b
#define SK_KEY_B             0x010e
#define SK_KEY_N             0x0111
#define SK_KEY_M             0x0114
#define SK_KEY_COMMA         0x0117
#define SK_KEY_DOT           0x011a
#define SK_KEY_SLASH         0x011d
#define SK_KEY_RSHIFT        0x0123
#define SK_KEY_UP            0x0129
#define SK_KEY_NUM1          0x012f
#define SK_KEY_NUM2          0x0132
#define SK_KEY_NUM3          0x0135
#define SK_KEY_NUMENTER      0x0138
#define SK_KEY_LCTRL         0x013b
#define SK_KEY_LWIN          0x013e
#define SK_KEY_LALT          0x0141
#define SK_KEY_SPACE         0x0144
#define SK_KEY_ALTGR         0x0147
#define SK_KEY_SHARKOON      0x014a
#define SK_KEY_MENU          0x014d
#define SK_KEY_RCTRL         0x0153
#define SK_KEY_LEFT          0x0165
#define SK_KEY_DOWN          0x0168
#define SK_KEY_RIGHT         0x016b
#define SK_KEY_NUM0          0x0171
#define SK_KEY_NUMDEL        0x0174

#define SK_LIMIT_KEY         0x0177      

typedef uint16_t skillerctl_keyaddr_t;

skillerctl_keyaddr_t skillerctl_keyaddr(const char* name);
char*                skillerctl_keystr(skillerctl_keyaddr_t key);

#endif /* KEYS_H */

