#include "usb.h"
#include "utils.h"
#include <stdlib.h>
#include <stdio.h>
#include <unistd.h>

libusb_device* skillerctl_find_device(libusb_device **devices, size_t count)
{   
    libusb_device *device;
    struct libusb_device_descriptor descriptor;

    for (unsigned i = 0; i < count; i++) {
        device = devices[i];

        libusb_get_device_descriptor(device, &descriptor);
        if (descriptor.idVendor == SK_VID && descriptor.idProduct == SK_PID) {
            return device;
        }
    }

    return NULL;
}

void skillerctl_send_command(libusb_device_handle *handle, skillerctl_packet_t *packet)
{
    // buffer for storing packed packet
    uint8_t buffer[SK_PACKET_SIZE];
    int     length;

    skillerctl_pack(packet, buffer);
    printf("Sending packet to keyboard: \n");
    hexdump(buffer, SK_PACKET_SIZE);

    ASSERT(libusb_control_transfer(
            handle, 
            LIBUSB_ENDPOINT_OUT | LIBUSB_REQUEST_TYPE_CLASS | LIBUSB_RECIPIENT_INTERFACE, 
            LIBUSB_REQUEST_SET_CONFIGURATION, 
            SK_CONFIGURATION, 
            SK_INTERFACE_CONTROL, 
            buffer, SK_PACKET_SIZE, 
            250
    ));

    ASSERT(libusb_interrupt_transfer(handle, SK_PORT_STATE, buffer, sizeof(buffer), &length, 250));

    printf("State from keyboard: \n");
    hexdump(buffer, length);
    usleep(5000);
}
