#include "utils.h"
#include <stdio.h>
#include <string.h>

void hexdump(void* data, size_t length)
{
    for (size_t read = 0; read < length; read += 16) {
        printf("%04zx", read);

        size_t to_read = length - read > 16 ? 16 : length - read;
        for (size_t byte = 0; byte < to_read; byte++) {
            printf(" %02X", ((unsigned char*)data)[read + byte]);
        }

        printf("\n");
    }
}

uint16_t skillerctl_lut_search(skillerctl_name_value_pair_t *lut, size_t n, const char* name)
{
    for (int i = 0; i < n; i++) {
        if (strcmp(lut[i].name, name) == 0) {
            return lut[i].value;
        }
    }

    return -1;
}
